
# coding: utf-8

# # Algo Toolbox and "<em>Pythoneries</em>"
# ## Lists

# ### <b><font color="blue">Exercise: Split List</font></b>
# Write a function that split a list of length <tt>n</tt>, with n odd, into 3 parts: 
# - the elements of the first half of the list (without the middle one)
# - the middle element
# - the elements of the second half of the list (without the middle one)
# 

# In[ ]:

def splitlist(L):
    #FIXME


# #### Pythonery
# This can be simplified with <em>Python list slices</em>:
# - L[a:b] is the sub list of L with elements from positions a to b (b excluded)
# - L[:a] is the list L[0:a]
# - L[a:] is the list L[b:len(n)]
# - L[-1] is L[len(L)]

# In[ ]:

def splitlist(L):
        #FIXME


# In[ ]:

L = [1, 2, 3, 4, 5, 6, 7, 8, 9]
splitlist(L)


# ### <b><font color="blue">Exercise: Binary Search</font></b>
# Write two functions to search an element in a sorted (in increasing order) list:
# - <tt>binarysearch(L, x, left, right)</tt> returns the position where <tt>x</tt> is or might be in <tt>L[left, right[</tt>, with  <tt>L</tt> sorted in increasing order.
# 

# In[ ]:

def binarysearch(L, x, left, right):
    """Binary Search
    
    Args:
        L: List to search in
        x: Value to search
        left, right: Search intervalle in L [left, right[
        
    Returns:
        The position where x is or might be
    """

    #FIXME


# In[ ]:

L = [-3, 0, 5, 8, 13, 24, 32, 37, 42]


# In[ ]:

binarysearch(L, 0, 0, len(L))


# - <tt>listSearch(L, x)</tt> returns <tt>-1</tt> if <tt>x</tt> in not in the list <tt>L</tt>, its position otherwise

# In[ ]:

def listsearch(L, x):
    #FIXME


# #### Pythonery
# Use <em>Python "ternary" operator</em>:
# <tt>[on_true] if [expression] else [on_false]</tt>

# In[ ]:

def listsearch2(x, L):
    #FIXME


# ### <b><font color="blue">Exercise: Build List &rarr; Build Matrix</font></b>
# Write the function <tt>buildlist(nb, val = None, alea = None)</tt> that builds a new list of length <tt>nb</tt>:
# - <tt>buildlist(nb)</tt> returns  <tt>[None, None, ...]</tt>
# - <tt>buildlist(nb, val)</tt> returns <tt>[val, val, ...]</tt>
# - <tt>buildlist(nb, alea = (a, b))</tt> returns a list of <tt>nb</tt> random values in <tt>[a, b[</tt>

# Note: <tt>if a:</tt> is <tt>False</tt> when <tt>a</tt> is <tt>0, None, [], "" ...</tt>

# In[ ]:

# Reminder on imports, random and seed
import random
help(random.randint)


# In[ ]:

help(random.seed)
random.seed()    # do it once only!


# In[ ]:

def buildlist(nb, val = None, alea = None):
    #FIXME


# #### Pythonery
# <em>Python gives a short way to build list</em>: <tt>[val] * nb</tt>

# In[ ]:

def buildlist(nb, val = None, alea = None):
    #FIXME


# Test the "short" version ([val] * n) with random numbers...

# In[ ]:

[random.randint(0, 10)] * 5


# #### Pythonery: "list comprehension"
# Test the following, then use it to write again <code>buildlist</code>

# In[ ]:

[i for i in range(10)]


# In[ ]:

def buildList(nb, val = None, alea = None):
    #FIXME


# In[ ]:

buildlist(5), buildList(5, 0), buildList(5, alea = (0,10))


# #### <font color="red">WARNING:</font>
# when you want to build a list of lists

# In[ ]:

L = buildList(9, [])


# In[ ]:

L


# In[ ]:

L[0].append(1)


# In[ ]:

L


# Write again <tt>buildlist</tt> to avoid the problem

# In[ ]:

def buildlist(nb, val = None, alea = None):
    #FIXME


# <font color="blue">Use <tt>buildlist</tt> to build a (5*5) matrix filled with None, then change a value

# In[ ]:

M = buildlist(4, buildlist(5, None))


# In[ ]:

M


# In[ ]:

M[0][0] = 5


# In[ ]:

M


# Write a function <tt>buildmatrix(line, col, val = None)</tt> that builds a <tt>(line*col)</tt> matrix filled with <tt>val</tt>.

# In[ ]:

def buildmatrix(line, col, val = None):
     #FIXME


# In[ ]:


M = buildmatrix(4, 5)
M[0][0] = 3
M

